import { system, world, ItemStack } from "@minecraft/server";
//remove chest ui,rename addon,dependancy
system.runInterval(() => {
  for (const player of world.getAllPlayers()) {
    const raycastHit = player.getBlockFromViewDirection();
    const entityRaycast = player.getEntitiesFromViewDirection({maxDistance:15});
    if (raycastHit !== undefined) {
      if (raycastHit.block.isValid()) {
        const blockLookedAt = raycastHit.block;

        if (blockLookedAt.typeId == "chest:infinite_chest") {
          let tags = player.getTags();
          let exist = false;
          let entityId;
          tags.forEach((element) => {
            if (element.startsWith("temp_chest:")) {
              exist = true;
              entityId = element.replace("temp_chest:", "");
            }
          });

          let entityExist = player.dimension.getEntities({
            type: "chest:temp_chest",
            location: blockLookedAt.location,
            maxDistance: 1,
          });
          if (
            entityExist[0] == undefined ||
            entityExist[0]?.id.includes(entityId)
          ) {
            if (!player.isSneaking) {
              if (!exist) {
                let entity = player
                  .dimension
                  .spawnEntity("chest:temp_chest", blockLookedAt.location);
                const tameable = entity.getComponent("minecraft:tameable");
                tameable.tame(player);
                player.addTag("temp_chest:" + entity.id);
                entity.addTag("page:0");
                entity.nameTag = "§c§h§e§s§t§l§3Infinite Chest";
              } else {
                try {
                  let entity = world.getEntity(entityId);
                  let targetLoc = blockLookedAt.location;
                  let playerLoc = player.location;
                  let initx = Math.floor(targetLoc.x - playerLoc.x);
                  let inity = Math.floor(targetLoc.y - playerLoc.y);
                  let initz = Math.floor(targetLoc.z - playerLoc.z);

                  let x, y, z;
                  x =
                    initx > 0
                      ? targetLoc.x - 1
                      : initx < 0
                      ? targetLoc.x + 1
                      : targetLoc.x;
                  y =
                    inity > 0
                      ? targetLoc.y - 1
                      : inity < 0
                      ? targetLoc.y + 1
                      : targetLoc.y;
                  z =
                    initz > 0
                      ? targetLoc.z - 1
                      : initz < 0
                      ? targetLoc.z + 1
                      : targetLoc.z;
                  if (
                    entity.location.x != Math.floor(x) &&
                    entity.location.y != Math.floor(y) &&
                    entity.location.z != Math.floor(z)
                  ) {
                    entity.teleport({ x: x, y: y, z: z });
                  }
                } catch {
                  cleanUp(player);
                }
              }
            } else {
              let tags = player.getTags();
              let exist = false;
              tags.forEach((element) => {
                if (element.startsWith("temp_chest:")) {
                  exist = true;
                }
              });
              if (exist) {
                cleanUp(player);
              }
            }
          }
        } else {
          let tags = player.getTags();
          let exist = false;
          tags.forEach((element) => {
            if (element.startsWith("temp_chest:")) {
              exist = true;
            }
          });
          if (exist) {
            cleanUp(player);
          }
        }
      }
    }

    if (entityRaycast !== undefined && entityRaycast[0] !== undefined) {
      if (entityRaycast[0].entity.isValid()) {
        if (entityRaycast[0].entity.typeId == "chest:temp_chest") {
          let temptags = player.getTags();
          let tempentity = undefined;
          temptags.forEach((element) => {
            if (element.startsWith("temp_chest:")) {
              let entityId = element.replace("temp_chest:", "");
              tempentity = world.getEntity(entityId);
            }
          });
          if (tempentity != undefined) {
            if (tempentity.id.startsWith(entityRaycast[0].entity.id)) {
              let entitytags = entityRaycast[0].entity.getTags();
              let prepared = false;
              entitytags.forEach((element) => {
                if (element.startsWith("prepared")) {
                  prepared = true;
                }
              });

              if (!prepared) {
                let tags = player.getTags();
                let exist = false;
                let entityId;
                tags.forEach((element) => {
                  if (element.startsWith("entityid:page0")) {
                    exist = true;
                    entityId = element.split(",")[1];
                  }
                });
                if (!exist) {
                  //player.sendMessage("initialized storage");
                  let entity = player
                    .dimension
                    .spawnEntity("chest:chest", player.location);
                  player.addTag("entityid:page0," + entity.id);
                  entityId = entity.id;
                  const entityinventory = entity.getComponent(
                    "minecraft:inventory"
                  ).container;
                  const playerinventory = player.getComponent(
                    "minecraft:inventory"
                  ).container;
                  preparechest(entityinventory, entityRaycast[0].entity, 0);
                }

                try {
                  let entity = world.getEntity(entityId);
                  const entityinventory = entity.getComponent(
                    "minecraft:inventory"
                  ).container;
                  const playerinventory = player.getComponent(
                    "minecraft:inventory"
                  ).container;
                  //player.sendMessage("storage loaded");
                  preparechest(entityinventory, entityRaycast[0].entity, 0);
                } catch {
                  let tags = player.getTags();
                  tags.forEach((element) => {
                    if (element.startsWith("entityid:page0")) {
                      player.removeTag(element);
                    }
                  });
                  //player.sendMessage("entity retrieved from structure");
                  let manager = world.structureManager;
                  let structurename = "chest:chest0" + player.id;
                  manager.place(
                    structurename,
                    player.dimension,
                    { x: player.location.x, y: 125, z: player.location.z },
                    { saveMode: "World", includeEntities: true }
                  );
                  for (const entity of player.dimension.getEntitiesAtBlockLocation(
                    { x: player.location.x, y: 125, z: player.location.z }
                  )) {
                    if (entity.typeId == "chest:chest") {
                      player.addTag("entityid:page0," + entity.id);
                    }
                  }
                }
              } else {
                let page;
                entitytags.forEach((element) => {
                  if (element.startsWith("page:")) {
                    page = JSON.parse(element.replace("page:", ""));
                  }
                });
                try {
                  let item;
                  const entityinventory = entityRaycast[0].entity.getComponent(
                    "minecraft:inventory"
                  ).container;
                  item = entityinventory.getItem(62);
                  if (!item.typeId.startsWith("chest:next_page")) {
                    clearItems(player);
                    syncItems(player, entityinventory, page);
                    pagebutton(player, entityRaycast[0].entity, page + 1);
                  }
                } catch {
                  const tempInventory = entityRaycast[0].entity.getComponent(
                    "minecraft:inventory"
                  ).container;
                  clearItems(player);
                  syncItems(player, tempInventory, page);
                  pagebutton(player, entityRaycast[0].entity, page + 1);
                }
                if (page > 0) {
                  try {
                    let item;
                    const entityinventory =
                      entityRaycast[0].entity.getComponent(
                        "minecraft:inventory"
                      ).container;
                    item = entityinventory.getItem(61);
                    if (!item.typeId.startsWith("chest:previous_page")) {
                      clearItems(player);
                      syncItems(player, entityinventory, page);
                      pagebutton(player, entityRaycast[0].entity, page - 1);
                    }
                  } catch {
                    const tempInventory = entityRaycast[0].entity.getComponent(
                      "minecraft:inventory"
                    ).container;
                    clearItems(player);
                    syncItems(player, tempInventory, page);
                    pagebutton(player, entityRaycast[0].entity, page - 1);
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}, 1);

function clearItems(player) {
  player.runCommand("clear @s chest:next_page");
  player.runCommand("clear @s chest:previous_page");
}

function pagebutton(player, temp_entity, page) {
  let previouspage;
  let entitTags = temp_entity.getTags();
  entitTags.forEach((element) => {
    if (element.startsWith("page:")) {
      previouspage = JSON.parse(element.replace("page:", ""));
    }
  });

  if (Math.floor(page / 4) == Math.floor(previouspage / 4)) {
    let tags = player.getTags();
    let entityId;
    tags.forEach((element) => {
      if (
        element.startsWith(
          "entityid:page" + JSON.stringify(Math.floor(page / 4)) + ","
        )
      ) {
        entityId = element.split(",")[1];
      }
    });
    let entity = world.getEntity(entityId);
    const entityinventory = entity.getComponent(
      "minecraft:inventory"
    ).container;
    preparechest(entityinventory, temp_entity, page);
  } else {
    let tags = player.getTags();
    let previouschestEntity;
    tags.forEach((element) => {
      if (
        element.startsWith(
          "entityid:page" + JSON.stringify(Math.floor(previouspage / 4)) + ","
        )
      ) {
        previouschestEntity = world.getEntity(element.split(",")[1]);
      }
    });
    let structurename =
      "chest:chest" + JSON.stringify(Math.floor(previouspage / 4)) + player.id;
    try {
      let manager = world.structureManager;
      manager.createFromWorld(
        structurename,
        previouschestEntity.dimension,
        previouschestEntity.location,
        previouschestEntity.location,
        { saveMode: "World", includeEntities: true }
      );
    } catch {
      let manager = world.structureManager;
      manager.delete(structurename);
      manager.createFromWorld(
        structurename,
        previouschestEntity.dimension,
        previouschestEntity.location,
        previouschestEntity.location,
        { saveMode: "World", includeEntities: true }
      );
    }
    previouschestEntity.remove();

    let exist = false;
    let entityId;
    tags.forEach((element) => {
      if (
        element.startsWith(
          "entityid:page" + JSON.stringify(Math.floor(page / 4)) + ","
        )
      ) {
        exist = true;
        entityId = element.split(",")[1];
      }
    });
    if (!exist) {
      //player.sendMessage("initialized storage");
      let entity = player
        .dimension
        .spawnEntity("chest:chest", player.location);
      player.addTag(
        "entityid:page" + JSON.stringify(Math.floor(page / 4)) + "," + entity.id
      );
      entityId = entity.id;
      const entityinventory = entity.getComponent(
        "minecraft:inventory"
      ).container;
      const playerinventory = player.getComponent(
        "minecraft:inventory"
      ).container;
      preparechest(entityinventory, temp_entity, page);
    }

    try {
      let entity = world.getEntity(entityId);
      const entityinventory = entity.getComponent(
        "minecraft:inventory"
      ).container;
      const playerinventory = player.getComponent(
        "minecraft:inventory"
      ).container;
      //player.sendMessage("storage loaded");
      preparechest(entityinventory, temp_entity, page);
    } catch {
      let tags = player.getTags();
      tags.forEach((element) => {
        if (
          element.startsWith(
            "entityid:page" + JSON.stringify(Math.floor(page / 4)) + ","
          )
        ) {
          player.removeTag(element);
        }
      });
      //player.sendMessage("entity retrieved from structure");
      let manager = world.structureManager;
      let structurename =
        "chest:chest" + JSON.stringify(Math.floor(page / 4)) + player.id;
      manager.place(
        structurename,
        player.dimension,
        { x: player.location.x, y: 125, z: player.location.z },
        { saveMode: "World", includeEntities: true }
      );
      for (const entity of player.dimension.getEntitiesAtBlockLocation({
        x: player.location.x,
        y: 125,
        z: player.location.z,
      })) {
        if (entity.typeId == "chest:chest") {
          player.addTag(
            "entityid:page" +
              JSON.stringify(Math.floor(page / 4)) +
              "," +
              entity.id
          );
          const entityinventory = entity.getComponent(
            "minecraft:inventory"
          ).container;
          const playerinventory = player.getComponent(
            "minecraft:inventory"
          ).container;
          //player.sendMessage("storage loaded");
          preparechest(entityinventory, temp_entity, page);
        }
      }
    }
  }
}

function syncItems(player, tempInventory, page) {
  let tags = player.getTags();
  let entityId;
  tags.forEach((element) => {
    if (
      element.startsWith(
        "entityid:page" + JSON.stringify(Math.floor(page / 4)) + ","
      )
    ) {
      entityId = element.split(",")[1];
    }
  });
  let entity = world.getEntity(entityId);
  const entityinventory = entity.getComponent("minecraft:inventory").container;

  for (let i = 0 + 61 * (page % 4); i < 61 * ((page % 4) + 1); i++) {
    try {
      let item = tempInventory.getItem(i - 61 * (page % 4));
      entityinventory.setItem(
        i,
        item.typeId.includes("chest:next_page") ||
          item.typeId.includes("chest:previous_page")
          ? "minecraft:air"
          : item
      );
    } catch {
      entityinventory.setItem(i, new ItemStack("minecraft:air", 1));
      continue;
    }
  }
  try {
    if (
      !tempInventory.getItem(61).typeId.startsWith("minecraft:air") &&
      !tempInventory.getItem(61).typeId.startsWith("chest:previous_page") &&
      !tempInventory.getItem(61).typeId.startsWith("chest:next_page")
    ) {
      player.dimension.spawnItem(tempInventory.getItem(61), player.location);
    }
  } catch {}
  try {
    if (
      !tempInventory.getItem(62).typeId.startsWith("minecraft:air") &&
      !tempInventory.getItem(62).typeId.startsWith("chest:next_page") &&
      !tempInventory.getItem(62).typeId.startsWith("chest:previous_page")
    ) {
      player.dimension.spawnItem(tempInventory.getItem(62), player.location);
    }
  } catch {}
}

function preparechest(entityinv, tempEntity, page) {
  const tempInventory = tempEntity.getComponent(
    "minecraft:inventory"
  ).container;
  for (let i = 0 + 61 * (page % 4); i < 61 * ((page % 4) + 1); i++) {
    let slot;
    try {
      slot = entityinv.getItem(i);
      tempInventory.setItem(i - 61 * (page % 4), slot);
    } catch {
      tempInventory.setItem(
        i - 61 * (page % 4),
        new ItemStack("minecraft:air", 1)
      );
      continue;
    }
  }
  let item = new ItemStack("chest:next_page", 1);
  item.nameTag = "§l§3Page §a" + JSON.stringify(page + 2);
  item.setLore(["§r§7Go to next page"]);
  tempInventory.setItem(62, item);
  if (page > 0) {
    let item = new ItemStack("chest:previous_page", 1);
    item.nameTag = "§l§3Page §a" + JSON.stringify(page);
    item.setLore(["§r§7Go to previous page"]);
    tempInventory.setItem(61, item);
  } else {
    tempInventory.setItem(61, new ItemStack("minecraft:air", 1));
  }
  let entitytags = tempEntity.getTags();
  entitytags.forEach((element) => {
    if (element.startsWith("page:")) {
      tempEntity.removeTag(element);
    }
  });
  tempEntity.addTag("prepared");
  tempEntity.addTag("page:" + JSON.stringify(page));
}

function cleanUp(player) {
  const raycastHit = player.getBlockFromViewDirection();
  if (raycastHit !== undefined) {
    if (raycastHit.block.isValid()) {
      const blockLookedAt = raycastHit.block;
      if (blockLookedAt.typeId != "chest:infinite_chest" || player.isSneaking) {
        let tags = player.getTags();
        let entity = undefined;
        tags.forEach((element) => {
          if (element.startsWith("temp_chest:")) {
            let entityId = element.replace("temp_chest:", "");
            player.removeTag(element);
            entity = world.getEntity(entityId);
          }
        });
        let prepared = entity.hasTag("prepared");
        let page;
        let entitTags = entity.getTags();
        entitTags.forEach((element) => {
          if (element.startsWith("page:")) {
            page = JSON.parse(element.replace("page:", ""));
          }
        });

        let exist = false;
        let entityid;
        let entitychest;
        try {
          tags.forEach((element) => {
            if (
              element.startsWith(
                "entityid:page" + JSON.stringify(Math.floor(page / 4)) + ","
              )
            ) {
              entitychest = world.getEntity(element.split(",")[1]);
              entityid = entitychest.id;
              exist = true;
            }
          });
        } catch {
          exist = false;
          entity.remove();
        }

        if (exist && prepared) {
          //player.sendMessage("syncing");

          if (entity !== undefined) {
            //try {

            const tempInventory = entity.getComponent(
              "minecraft:inventory"
            ).container;
            tempInventory.setItem(61, new ItemStack("minecraft:air", 1));
            tempInventory.setItem(62, new ItemStack("minecraft:air", 1));
            clearItems(player);
            syncItems(player, tempInventory, page);
            entity.remove();
            let chestEntity;
            tags.forEach((element) => {
              if (
                element.startsWith(
                  "entityid:page" + JSON.stringify(Math.floor(page / 4)) + ","
                )
              ) {
                chestEntity = world.getEntity(element.split(",")[1]);
              }
            });
            let structurename =
              "chest:chest" + JSON.stringify(Math.floor(page / 4)) + player.id;
            try {
              let manager = world.structureManager;
              manager.createFromWorld(
                structurename,
                chestEntity.dimension,
                chestEntity.location,
                chestEntity.location,
                { saveMode: "World", includeEntities: true }
              );
            } catch {
              let manager = world.structureManager;
              manager.delete(structurename);
              manager.createFromWorld(
                structurename,
                chestEntity.dimension,
                chestEntity.location,
                chestEntity.location,
                { saveMode: "World", includeEntities: true }
              );
            }
            chestEntity.remove();
            //player.sendMessage("stored entity in structure");

            // }
            // catch {
            // 	player.sendMessage("catch");
            // }
          }
        } else {
          try {
            entity.remove();
            entitychest.remove();
          } catch {}
        }
      }
    }
  }
}
system.afterEvents.scriptEventReceive.subscribe((data) => {
  data.sourceEntity.sendMessage("§aAttempting to clean chests")
  if(data.id == "chest:clean") {
    for (const player of world.getAllPlayers()) {
    let tags = player.getTags();
    tags.forEach((element) => {
      if (element.startsWith("entityid:page")) {
        try {
          let entity = world.getEntity(element.split(",")[1]);
          entity.remove();
          player.sendMessage("§aError fixed");
        } catch {}
        //player.sendMessage("deleted tag: "+element);
      }
      if (element.startsWith("temp_chest:")) {
        try {
          let entityId = element.replace("temp_chest:", "");
          let entity = world.getEntity(entityId);
          entity.remove();
          player.sendMessage("§aError fixed");
        } catch {}
        player.removeTag(element);
      }
    });
  }
}
});